DPDK patches and discussions
 help / color / mirror / Atom feed
From: Arnon Warshavsky <arnon@qwilt.com>
To: thomas@monjalon.net, anatoly.burakov@intel.com,
	wenzhuo.lu@intel.com, declan.doherty@intel.com,
	jerin.jacob@caviumnetworks.com, bruce.richardson@intel.com,
	ferruh.yigit@intel.com
Cc: dev@dpdk.org, arnon@qwilt.com
Subject: [dpdk-dev] [PATCH v11] devtools: alert on new instances of rte_panic and rte_exit
Date: Mon, 16 Jul 2018 14:37:57 +0300	[thread overview]
Message-ID: <1531741077-5513-1-git-send-email-arnon@qwilt.com> (raw)
In-Reply-To: <1525070752-21085-1-git-send-email-arnon@qwilt.com>

This patch adds a new function that is called
per every checked patch,
and alerts for new instances of rte_panic/rte_exit.
The check excludes comments, and alerts in the case
of a positive balance between additions and removals.

Signed-off-by: Arnon Warshavsky <arnon@qwilt.com>
Reviewed-by: Stephen Hemminger <stephen@networkplumber.org>
---

v11 
- Use Neils tmpfile infrastructure to consume the patches
- Allow different calls to the awk script decide if they want
  to fail the check or just warn

 devtools/checkpatches.sh | 95 ++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 95 insertions(+)

diff --git a/devtools/checkpatches.sh b/devtools/checkpatches.sh
index 1439bce..22832ef 100755
--- a/devtools/checkpatches.sh
+++ b/devtools/checkpatches.sh
@@ -43,6 +43,94 @@ print_usage () {
 	END_OF_HELP
 }
 
+
+check_forbidden_additions() { # <file>
+    # ---------------------------------
+    #This awk script receives a list of expressions to monitor
+    #and a list of folders to search these expressions in
+    # - No search is done inside comments
+    # - Both additions and removals of the expressions are checked
+    #   A positive balance of additions fails the check
+	read -d '' awk_script << 'EOF'
+	BEGIN{
+		split(FOLDERS,deny_folders," ");
+		split(EXPRESSIONS,deny_expr," ");
+		in_file=0;
+		in_comment=0;
+		count=0;
+		comment_start="/*"
+		comment_end="*/"
+	}
+	# search for add/remove instances in current file
+	# state machine assumes the comments structure is enforced by
+	# checkpatches.pl
+	(in_file) {
+		# comment start
+		if (index($0,comment_start) > 0){
+			in_comment = 1
+		}
+		# non comment code
+		if (in_comment == 0) {
+			for (i in deny_expr) {
+				forbidden_added = "^\+.*" deny_expr[i];
+				forbidden_removed="^-.*" deny_expr[i];
+				current = expressions[deny_expr[i]]
+				if ($0 ~ forbidden_added) {
+					count = count + 1;
+					expressions[deny_expr[i]] = current + 1
+				}
+				if ($0 ~ forbidden_removed) {
+					count = count - 1;
+					expressions[deny_expr[i]] = current - 1
+				}
+			}
+		}
+
+		# comment end
+		if (index($0,comment_end) > 0)  {
+			in_comment = 0
+		}
+	}
+	# switch to next file , check if the balance of add/remove
+	# of previous filehad new additions
+	($0 ~ "^\+\+\+ b/") {
+		in_file = 0;
+		if (count > 0){
+			exit;
+		}
+		for (i in deny_folders){
+			re = "^\+\+\+ b/" deny_folders[i];
+			if ($0 ~ deny_folders[i]) {
+				in_file = 1
+				last_file = $0
+			}
+		}
+	}
+	END{
+		if (count > 0){
+			warnText = "\\033[1;31m" "Warning:" "\\033[0m"
+			print warnText " in " substr(last_file,6) ":"
+			print "are you sure you want to add the following:"
+			for (key in expressions) {
+				if (expressions[key] > 0) {
+					print key
+				}
+			}
+			exit RET_ON_FAIL
+		}
+	}
+EOF
+	# ---------------------------------
+
+	# refrain from new additions of rte_panic() and rte_exit()
+	# under lib and net
+	# multiple folders and expressions are separated by spaces
+	awk -v FOLDERS="lib net" \
+		-v EXPRESSIONS="rte_panic\\\( rte_exit\\\(" \
+		-v RET_ON_FAIL=0 \
+		"$awk_script" -
+}
+
 number=0
 quiet=false
 verbose=false
@@ -97,6 +185,13 @@ check () { # <patch> <commit> <title>
 		ret=1
 	fi
 
+	! $verbose || printf '\nChecking forbidden tokens additions/removals:\n'
+	report=$(cat $tmpinput | check_forbidden_additions)
+	if [ $? -ne 0 ] ; then
+		ret=1
+	fi
+	printf '%s\n' "$report"
+
 	clean_tmp_files
 	[ $ret -eq 0 ] && return 0
 
-- 
1.8.3.1

  parent reply	other threads:[~2018-07-16 11:38 UTC|newest]

Thread overview: 91+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2018-04-24 22:16 [dpdk-dev] [PATCH v7 00/11] eal: replace calls to rte_panic and refrain from new instances Arnon Warshavsky
2018-04-24 22:16 ` [dpdk-dev] [PATCH v7 01/11] crypto/dpaa: replace rte_panic instances in crypto/dpaa driver Arnon Warshavsky
2018-04-26 16:05   ` Kevin Traynor
2018-04-26 16:16     ` Kevin Traynor
2018-04-26 21:28     ` Arnon Warshavsky
2018-04-27 10:08       ` Kevin Traynor
2018-04-24 22:16 ` [dpdk-dev] [PATCH v7 02/11] bond: replace rte_panic instances in bonding driver Arnon Warshavsky
2018-04-24 22:51   ` Stephen Hemminger
2018-04-25  9:38     ` Arnon Warshavsky
2018-04-24 22:16 ` [dpdk-dev] [PATCH v7 03/11] e1000: replace rte_panic instances in e1000 driver Arnon Warshavsky
2018-04-24 22:16 ` [dpdk-dev] [PATCH v7 04/11] ixgbe: replace rte_panic instances in ixgbe driver Arnon Warshavsky
2018-04-24 22:16 ` [dpdk-dev] [PATCH v7 05/11] eal: replace rte_panic instances in eventdev Arnon Warshavsky
2018-04-24 22:16 ` [dpdk-dev] [PATCH v7 06/11] kni: replace rte_panic instances in kni Arnon Warshavsky
2018-04-24 22:16 ` [dpdk-dev] [PATCH v7 07/11] eal: replace rte_panic instances in hugepage_info Arnon Warshavsky
2018-04-25  8:58   ` Burakov, Anatoly
2018-04-24 22:16 ` [dpdk-dev] [PATCH v7 08/11] eal: replace rte_panic instances in interrupts thread Arnon Warshavsky
2018-04-25  9:14   ` Burakov, Anatoly
2018-04-25  9:37     ` Arnon Warshavsky
2018-04-24 22:16 ` [dpdk-dev] [PATCH v7 09/11] eal: replace rte_panic instances in ethdev Arnon Warshavsky
2018-04-24 22:16 ` [dpdk-dev] [PATCH v7 10/11] eal: replace rte_panic instances in init sequence Arnon Warshavsky
2018-04-25  9:07   ` Burakov, Anatoly
2018-04-25  9:33     ` Arnon Warshavsky
2018-04-24 22:16 ` [dpdk-dev] [PATCH v7 11/11] devtools: prevent new instances of rte_panic and rte_exit Arnon Warshavsky
2018-04-24 22:52   ` Stephen Hemminger
2018-04-24 23:03     ` Thomas Monjalon
2018-04-24 23:15       ` Stephen Hemminger
2018-04-25 13:45 ` [dpdk-dev] [PATCH v8 00/10] eal: replace calls to rte_panic and refrain from new instances Arnon Warshavsky
2018-04-25 13:45   ` [dpdk-dev] [PATCH v8 01/10] crypto/dpaa: replace rte_panic instances in crypto/dpaa driver Arnon Warshavsky
2018-04-25 13:45   ` [dpdk-dev] [PATCH v8 02/10] bond: replace rte_panic instances in bonding driver Arnon Warshavsky
2018-04-25 13:45   ` [dpdk-dev] [PATCH v8 03/10] e1000: replace rte_panic instances in e1000 driver Arnon Warshavsky
2018-04-25 13:45   ` [dpdk-dev] [PATCH v8 04/10] ixgbe: replace rte_panic instances in ixgbe driver Arnon Warshavsky
2018-04-25 13:45   ` [dpdk-dev] [PATCH v8 05/10] eal: replace rte_panic instances in eventdev Arnon Warshavsky
2018-04-25 13:45   ` [dpdk-dev] [PATCH v8 06/10] kni: replace rte_panic instances in kni Arnon Warshavsky
2018-04-25 13:45   ` [dpdk-dev] [PATCH v8 07/10] eal: replace rte_panic instances in hugepage_info Arnon Warshavsky
2018-04-25 13:50     ` Burakov, Anatoly
2018-04-25 14:02       ` Arnon Warshavsky
2018-04-25 14:14         ` Burakov, Anatoly
2018-04-25 13:45   ` [dpdk-dev] [PATCH v8 08/10] eal: replace rte_panic instances in ethdev Arnon Warshavsky
2018-04-25 13:45   ` [dpdk-dev] [PATCH v8 09/10] eal: replace rte_panic instances in init sequence Arnon Warshavsky
2018-04-25 13:53     ` Burakov, Anatoly
2018-04-25 13:45   ` [dpdk-dev] [PATCH v8 10/10] devtools: prevent new instances of rte_panic and rte_exit Arnon Warshavsky
2018-04-26  6:20     ` [dpdk-dev] [PATCH v9 00/10] eal: replace calls to rte_panic and refrain from new instances Arnon Warshavsky
2018-04-26  6:20       ` [dpdk-dev] [PATCH v9 01/10] crypto/dpaa: replace rte_panic instances in crypto/dpaa driver Arnon Warshavsky
2018-04-26  6:20       ` [dpdk-dev] [PATCH v9 02/10] bond: replace rte_panic instances in bonding driver Arnon Warshavsky
2018-04-26 16:06         ` Kevin Traynor
2018-04-26 21:06           ` Arnon Warshavsky
2018-04-26 21:26             ` Thomas Monjalon
2018-04-26  6:20       ` [dpdk-dev] [PATCH v9 03/10] e1000: replace rte_panic instances in e1000 driver Arnon Warshavsky
2018-04-26  6:20       ` [dpdk-dev] [PATCH v9 04/10] ixgbe: replace rte_panic instances in ixgbe driver Arnon Warshavsky
2018-04-26  6:20       ` [dpdk-dev] [PATCH v9 05/10] eal: replace rte_panic instances in eventdev Arnon Warshavsky
2018-04-26  6:21       ` [dpdk-dev] [PATCH v9 06/10] kni: replace rte_panic instances in kni Arnon Warshavsky
2018-04-26  6:21       ` [dpdk-dev] [PATCH v9 07/10] eal: replace rte_panic instances in hugepage_info Arnon Warshavsky
2018-04-26  6:21       ` [dpdk-dev] [PATCH v9 08/10] eal: replace rte_panic instances in ethdev Arnon Warshavsky
2018-04-26 16:07         ` Kevin Traynor
2018-04-26 21:38           ` Arnon Warshavsky
2018-04-26  6:21       ` [dpdk-dev] [PATCH v9 09/10] eal: replace rte_panic instances in init sequence Arnon Warshavsky
2018-04-26 16:07         ` Kevin Traynor
2018-04-26 22:08           ` Arnon Warshavsky
2018-04-26 22:27             ` Arnon Warshavsky
2018-04-27  9:56             ` Kevin Traynor
2018-04-26  6:21       ` [dpdk-dev] [PATCH v9 10/10] devtools: prevent new instances of rte_panic and rte_exit Arnon Warshavsky
2018-04-26 16:08         ` Kevin Traynor
2018-04-26 21:57           ` Arnon Warshavsky
2018-04-27 10:02             ` Kevin Traynor
2018-04-29  6:23               ` Arnon Warshavsky
2018-04-30  6:45         ` [dpdk-dev] [PATCH v10] devtools: alert on " Arnon Warshavsky
2018-05-04 16:42           ` Kevin Traynor
2018-05-27 19:47           ` Thomas Monjalon
2018-05-27 20:34             ` Arnon Warshavsky
2018-07-15 23:15               ` Thomas Monjalon
2018-07-16 11:37           ` Arnon Warshavsky [this message]
2018-07-16 12:44             ` [dpdk-dev] [PATCH v12] " Arnon Warshavsky
2018-07-26 20:29               ` Thomas Monjalon
2018-07-26 20:57                 ` Arnon Warshavsky
2018-07-26 21:00                   ` Thomas Monjalon
2018-07-26 21:42                 ` Arnon Warshavsky
2018-07-26 21:56                 ` Thomas Monjalon
2018-07-26 22:00                   ` Arnon Warshavsky
2018-07-26 22:10               ` [dpdk-dev] [PATCH v13] " Arnon Warshavsky
2018-07-31 12:11                 ` Thomas Monjalon
2018-07-31 12:32                   ` Arnon Warshavsky
2018-07-31 12:38                 ` Thomas Monjalon
2018-09-10  6:06                   ` David Marchand
2018-09-10  6:17                     ` Arnon Warshavsky
2018-09-10  6:24                       ` David Marchand
2018-04-27 14:22       ` [dpdk-dev] [PATCH v9 00/10] eal: replace calls to rte_panic and refrain from new instances Thomas Monjalon
2018-04-27 16:31         ` Arnon Warshavsky
2018-04-27 16:40           ` Thomas Monjalon
2018-04-27 17:16             ` Arnon Warshavsky
2018-04-27 14:30       ` Thomas Monjalon
2018-04-25 15:59   ` [dpdk-dev] [PATCH v8 " Stephen Hemminger

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1531741077-5513-1-git-send-email-arnon@qwilt.com \
    --to=arnon@qwilt.com \
    --cc=anatoly.burakov@intel.com \
    --cc=bruce.richardson@intel.com \
    --cc=declan.doherty@intel.com \
    --cc=dev@dpdk.org \
    --cc=ferruh.yigit@intel.com \
    --cc=jerin.jacob@caviumnetworks.com \
    --cc=thomas@monjalon.net \
    --cc=wenzhuo.lu@intel.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).